addonName = ...

GearHelper.itemSlot = { INVTYPE_AMMO = "Ammo", INVTYPE_HEAD = "Head", INVTYPE_NECK = "Neck", INVTYPE_SHOULDER = "Shoulder", INVTYPE_BODY = "Body", INVTYPE_CHEST = "Chest", INVTYPE_ROBE = "Chest", INVTYPE_WAIST = "Waist", INVTYPE_LEGS = "Legs", INVTYPE_FEET = "Feet", INVTYPE_WRIST = "Wrist", INVTYPE_HAND = "Hands", INVTYPE_FINGER = { "Finger0", "Finger1" }, INVTYPE_TRINKET = { "Trinket0", "Trinket1" }, INVTYPE_CLOAK = "Back", INVTYPE_SHIELD = "SecondaryHand", INVTYPE_WEAPON = { "MainHand", "SecondaryHand" }, INVTYPE_2HWEAPON = { "MainHand", "SecondaryHand" }, INVTYPE_WEAPONMAINHAND = "MainHand", INVTYPE_WEAPONOFFHAND = "SecondaryHand", INVTYPE_HOLDABLE = "SecondaryHand", INVTYPE_RANGED = "MainHand", INVTYPE_RANGEDRIGHT = { "MainHand", "SecondaryHand" } }

local function ParseDefaultValues(rawValues, specID, templateID)
    local rawCopy = rawValues
    local tmpTemplate = {
        ["Intellect"] = 0,
        ["Haste"] = 0,
        ["CriticalStrike"] = 0,
        ["Versatility"] = 0,
        ["Mastery"] = 0,
        ["Agility"] = 0,
        ["Stamina"] = 0,
        ["Strength"] = 0,
        ["Armor"] = 0,
        ["Leech"] = 0,
        ["Avoidance"] = 0,
        ["MainHandDps"] = 0,
        ["MovementSpeed"] = 0,
        ["OffHandDps"] = 0,
        ["Max"] = 0
    }
    local lastWord = ""
    local count = 1

    for token in string.gmatch(rawCopy, "[^%s]+") do
        if count == 1 or count == 4 or count == 7 or count == 10 or count == 13 or count == 16 or count == 19 or count == 22 or count == 25 or count == 28 or count == 31 then
            lastWord = token
        end

        if count == 2 or count == 5 or count == 8 or count == 11 or count == 14 or count == 17 or count == 20 or count == 23 or count == 26 or count == 29 or count == 32 then
            --Refactoring some spelling from Noxxic and AMR
            if lastWord == "Crit" then
                lastWord = "CriticalStrike"
            end

            if lastWord == "OffHandDamage" then
                lastWord = "OffHandDps"
            end

            if lastWord == "MainHandDamage" then
                lastWord = "MainHandDps"
            end

            if string.gsub(token, "%[", "") then
                token = string.gsub(token, "%[", "")
            end
            if string.gsub(token, "%]", "") then
                token = string.gsub(token, "%]", "")
            end

            tmpTemplate[lastWord] = tonumber(token)
        end

        count = count + 1

    end

    for key, value in pairs(tmpTemplate) do
        if tmpTemplate.Max < value then
            tmpTemplate.Max = value
        end
    end

    if GearHelper.db.global.templates[specID] == nil then
        GearHelper.db.global.templates[specID] = {}
    end
    GearHelper.db.global.templates[specID][templateID] = tmpTemplate
end

function initTab( stats, Classe, cw )
    local stats = stats

    local hate = 01
    local intel = 01
    local maitrise = 01
    local critique = 01
    local vers = 01
    local agi = 01
    local endu = 01
    local force = 01
    local armure = 01
    local leech = 01
    local avoidance = 01
    local mainHandDamage = 01
    local movementSpeed = 01
    local offHandDamage = 01

    local lastWorld = ""
    local compteur = 1
    local max = 0

    --print(stats)

    for token in string.gmatch(stats, "[^%s]+") do
        if compteur == 1 or compteur == 4 or compteur == 7 or compteur == 10 or compteur == 13 or compteur == 16 or compteur == 19 or compteur == 22 or compteur == 25 or compteur == 28 or compteur == 31 then
            lastWorld = token
        end

        if compteur == 2 or compteur == 5 or compteur == 8 or compteur == 11 or compteur == 14 or compteur == 17 or compteur == 20 or compteur == 23 or compteur == 26 or compteur == 29 or compteur == 32 then
            if lastWorld == "Haste" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                hate = tonumber(token)
            end
            if lastWorld == "Intellect" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                intel = tonumber(token)
            end
            if lastWorld == "Mastery" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                maitrise = tonumber(token)
            end
            if lastWorld == "Crit"  or lastWorld == "CriticalStrike" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                critique = tonumber(token)
            end
            if lastWorld == "Versatility" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                vers = tonumber(token)
            end
            if lastWorld == "Agility" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                agi = tonumber(token)
            end
            if lastWorld == "Stamina" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                endu = tonumber(token)
            end
            if lastWorld == "Strength" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                force = tonumber(token)
            end
            if lastWorld == "Armor" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                armure = tonumber(token)
            end
            if lastWorld == "Leech" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                leech = tonumber(token)
            end
            if lastWorld == "Avoidance" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                avoidance = tonumber(token)
            end
            if lastWorld == "MainHandDamage" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                mainHandDamage = tonumber(token)
            end
            if lastWorld == "MovementSpeed" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                movementSpeed = tonumber(token)
            end
            if lastWorld == "OffHandDamage" then
                if(string.sub(token,1,1) == "[") then
                    token = token:sub(1, -2)
                    token = string.sub(token, 2)
                end
                offHandDamage = tonumber(token)
            end
        end

        compteur = compteur + 1

    end

    if hate > intel then
        max = hate
    else
        max = intel
    end
    if max < maitrise then
        max = maitrise
    end
    if max < critique then
        max = critique
    end
    if max < vers then
        max = vers
    end
    if max < agi then
        max = agi
    end
    if max < endu then
        max = endu
    end
    if max < force then
        max = force
    end
    if max < armure then
        max = armure
    end
    if max < leech then
        max = leech
    end
    if max < avoidance then
        max = avoidance
    end
    if max < mainHandDamage then
        max = mainHandDamage
    end
    if max < movementSpeed then
        max = movementSpeed
    end

    -- if cw ~= true then
    --     GearHelper.Classe = { Intellect = intel, Haste = hate, CriticalStrike = critique, Versatility = vers, Mastery = maitrise, Agility = agi, Stamina = endu, Strength = force, Armor = armure, Leech = leech, Avoidance = avoidance, MainHandDps = mainHandDamage, MovementSpeed = movementSpeed, OffHandDps = offHandDamage, Max = max, N = 100, U = 100, L = 100}
    -- else
    --     if GHVar_customWeights == nil then
    --         GHVar_customWeights = {}
    --     end
    --     GHVar_customWeights[Classe] = { Intellect = intel, Haste = hate, CriticalStrike = critique, Versatility = vers, Mastery = maitrise, Agility = agi, Stamina = endu, Strength = force, Armor = armure, Leech = leech, Avoidance = avoidance, MainHandDps = mainHandDamage, MovementSpeed = movementSpeed, OffHandDps = offHandDamage, Max = max, N = 100, U = 100, L = 100 }
    --     for k, v in pairs(GHVar_customWeights[Classe]) do
    --         --print(k.." : "..v)
    --     end
    -- end

end

-- local rawValues = {
--     -- DK BLOOD --
--     ["250"] = {
--         ["NOX"] = "Stamina [12.01] > Strength [9.01] > Haste [7.51] > Versatility [6.01] > Mastery [4.51] > Crit [3.01]",
--         ["AMR"] = "Armor [50.36] > Versatility [12.4] Stamina [11.84] > Leech [10.57] > CriticalStrike [7.3] > Strength [5.66] > Haste [4.36] > Mastery [3.91] > Avoidance [0.92] > MainHandDamage [0.57] > MovementSpeed [0.01]",
--     },
--     -- DK FROST --
--     ["251"] = {
--         ["NOX"] = "Strength [9.01] > Mastery [7.51] > Crit [6.76] > Haste [6.01] > Versatility [5.26]",
--         ["AMR"] = "CriticalStrike [16.57] > Strength [16.15] > Mastery [12.4] > Haste [10.36] > Versatility [9.23] > MainHandDamage [6.47] > OffHandDamage [1.92] > MovementSpeed [0.03] > Avoidance [0.02] > Leech [0.01]",
--     },
--     -- DK UNHOLY --
--     ["252"] = {
--         ["NOX"] = "Strength [9.07] > Mastery [7.57] > Haste [6.07] > Crit [4.57] = Versatility [4.57]",
--         ["AMR"] = "Strength [15.48] > Mastery [12.34] > CriticalStrike [9.78] > Haste [9.05] > Versatility [8.7] > MainHandDamage [2.96] > MovementSpeed [0.03] > Avoidance [0.02] > Leech [0.01]",
--     },
--     -- DEMON HUNTER HAVOC --
--     ["577"] = {
--         ["NOX"] = "Crit [9.02] > Haste [7.52] > Versatility [6.02] > Agility [4.52] > Mastery [3.02]",
--         ["AMR"] = "Agility [16.46] > CriticalStrike [10.44] > Versatility [9.71] > MainHandDamage [9.3] > Mastery [8.18] > Haste [7.76] > OffHandDamage [2.4] > MovementSpeed [0.03] > Avoidance [0.02] > Leech [0.01]",
--     },
--     -- DEMON HUNTER VENGEANCE --
--     ["581"] = {
--         ["NOX"] = "Stamina [15.01] > Agility [12.01] > Versatility [9.01] > Mastery [7.51] = Haste [7.51] > Crit [4.51]",
--         ["AMR"] = "Armor [57.74] > Leech [14.44] > Versatility [11.15] > Stamina [10.39] > Agility [9.13] > Mastery [9.09] > CriticalStrike [7.65] > Haste [5.95] > Avoidance [1.37] > MainHandDamage [1.16] > MovementSpeed [0.01] > OffHandDamage [0]",
--     },
--     -- DRUID BALANCE --
--     ["102"] = {
--         ["NOX"] = "Haste [12.02] > Intellect [10.52] > Mastery [9.02] > Crit [7.52] > Versatility [6.02]",
--         ["AMR"] = "Intellect [14.19] > Mastery [12.74] > Haste [12.72] > CriticalStrike [10.32] > Versatility [9.59] > Avoidance [0.03] > MovementSpeed [0.02] > Leech [0.01]",
--     },
--     -- DRUID FERAL --
--     ["103"] = {
--         ["NOX"] = "Agility [12.02] > Crit [10.52] > Mastery [9.02] > Versatility [7.52] > Haste [6.02]",
--         ["AMR"] = "Agility [12.88] > CriticalStrike [7.95] > Mastery [7.08] > Versatility [6.93] > Haste [6.91] > MainHandDamage [6.61] > MovementSpeed [0.03] > Avoidance [0.02] > Leech [0.01]",
--     },
--     -- DRUID GUARDIAN --
--     ["104"] = {
--         ["NOX"] = "Stamina [18.04] > Versatility [14.29] > Mastery [13.54] > Haste [12.04] > Agility [10.54] > Crit [9.04]",
--         ["AMR"] = "Armor [106.39] > Leech [17.14] > Stamina [15.41] > Versatility [11.89] > Mastery [11.13] > Haste [5.65] > CriticalStrike [3.88] > Avoidance [3.56] > Agility [2.84] > MainHandDamage [0.71] > MovementSpeed [0.01]",
--     },
--     -- DRUID RESTORATION --
--     ["105"] = {
--         ["NOX"] = "Intellect [9.01] > Mastery [7.51] > Haste [6.38] > Crit [6.01] > Versatility [4.51]",
--         ["AMR"] = "Mastery [15.14] > Intellect [12.96] > CriticalStrike [9.81] > Versatility [8.91] > Haste [8.19] > Leech [4.86] > Avoidance [0.02] > MovementSpeed [0.01]",
--     },
--     -- HUNTER BEAST MASTERY --
--     ["253"] = {
--         ["NOX"] = "Agility [9.05] > Mastery [7.55] > Haste [6.05] > Crit [4.55] > Versatility [3.05]",
--         ["AMR"] = "Agility [19.07] > Mastery [16.92] > Haste [11.81] > CriticalStrike [11.72] > Versatility [10.34] > MainHandDamage [2.24] > Avoidance [0.03] > MovementSpeed [0.02] > Leech [0.01]",
--     },
--     -- HUNTER MARKSMANSHIP --
--     ["254"] = {
--         ["NOX"] = "Mastery [9.07] > Agility [7.57] > Crit [6.07] > Haste [4.57] > Versatility [3.07]",
--         ["AMR"] = "Mastery [18.74] > Agility [15.2] > Haste [13.1] > CriticalStrike [12.79] > MainHandDamage [12.5] > Versatility [10.48] > Avoidance [0.03] > MovementSpeed [0.02] > Leech [0.01]",
--     },
--     -- HUNTER SURVIVAL --
--     ["255"] = {
--         ["NOX"] = "Agility [9.06] > Haste [7.56] > Mastery [6.43] > Crit [6.06] > Versatility [4.56]",
--         ["AMR"] = "Agility [16.05] > CriticalStrike [9.52] > Versatility [9] > Haste [7.56] > MainHandDamage [3.58] > Mastery [1.6] > MovementSpeed [0.03] > Avoidance [0.02] > Leech [0.01]",
--     },
--     -- MAGE ARCANE --
--     ["62"] = {
--         ["NOX"] = "Intellect [9.08] > Mastery [7.58] > Crit [6.08] > Versatility [4.58] > Haste [3.08]",
--         ["AMR"] = "Intellect [11.68] > CriticalStrike [8.99] > Mastery [8.4] > Versatility [8.23] > Haste [7.89] > Avoidance [0.03] > MovementSpeed [0.02] > Leech [0.01]",
--     },
--     -- MAGE FIRE --
--     ["63"] = {
--         ["NOX"] = "Intellect [9.03] > Crit [7.53] > Mastery [6.03] > Haste [4.53] > Versatility [3.03]",
--         ["AMR"] = "Intellect 16.74 > Mastery 13.13 > CriticalStrike 12.68 > Haste 12.22 > Versatility 11.43 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- MAGE FROST --
--     ["64"] = {
--         ["NOX"] = "Intellect [9.07] > Haste [7.57] > Crit [6.07] > Versatility [4.57] > Mastery [3.07]",
--         ["AMR"] = "Haste 17.26 > Intellect 14.95 > CriticalStrike 12.07 > Versatility 10.05 > Mastery 5.28 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- MONK BREWMASTER --
--     ["268"] = {
--         ["NOX"] = "Stamina [15.02] > Agility [12.02] > Haste [9.02] > Mastery [7.52] = Crit [7.52] > Versatility [6.02]",
--         ["AMR"] = "Armor 52.17 > Leech 14.87 > Stamina 13.57 > Versatility 11.06 > Mastery 10.09 > CriticalStrike 7.47 > Agility 7.03 > Haste 6.36 > Avoidance 1.39 > MainHandDamage 0.02 > MovementSpeed 0.01",
--     },
--     -- MONK MISTWEAVER --
--     ["270"] = {
--         ["NOX"] = "Intellect [9.04] > Crit [7.54] > Versatility [6.04] > Mastery [4.54] > Haste [3.04]",
--         ["AMR"] = "Intellect 12.31 > CriticalStrike 9.1 > Versatility 8.47 > Mastery 8.19 > Haste 6.49 > Leech 3.98 > Avoidance 0.02 > MovementSpeed 0.01",
--     },
--     -- MONK WINDWALKER --
--     ["269"] = {
--         ["NOX"] = "Agility [9.07] > Mastery [7.57] > Crit [6.07] > Versatility [4.57] > Haste [3.07]",
--         ["AMR"] = "Agility 19.36 > CriticalStrike 10.44 > Mastery 10.14 > Versatility 9.62 > Haste 7.9 > MainHandDamage 1.36 > OffHandDamage 0.76 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- PALADIN HOLY --
--     ["65"] = {
--         ["NOX"] = "Intellect [9.07] > Crit [7.57] > Mastery [6.07] > Versatility [4.57] > Haste [3.07]",
--         ["AMR"] = "Intellect 11.29 > CriticalStrike 9.26 > Mastery 7.97 > Versatility 6.76 > Haste 2.92 > Leech 2.07 > Avoidance 0.02 > MovementSpeed 0.01",
--     },
--     -- PALADIN PROTECTION --
--     ["66"] = {
--         ["NOX"] = "Stamina [15.05] > Strength [12.05] > Haste [9.05] > Versatility [7.55] > Mastery [6.05] > Crit [4.55]",
--         ["AMR"] = "Armor 42.72 > Stamina 11.8 > Haste 10.8 > Versatility 9.25 > Mastery 8.49 > CriticalStrike 8 > Leech 7.87 > Strength 3.52 > Avoidance 3.27 > MainHandDamage 0.04 > MovementSpeed 0.01",
--     },
--     -- PALADIN RETRIBUTION --
--     ["70"] = {
--         ["NOX"] = "Strength [9.03] > Haste [7.53] > Crit [6.03] = Versatility [6.03] > Mastery [4.53]",
--         ["AMR"] = "Strength 14.92 > Haste 11.89 > CriticalStrike 11.11 > Versatility 9.9 > MainHandDamage 8.23 > Mastery 5.08 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- PRIEST HOLY --
--     ["257"] = {
--         ["NOX"] = "Intellect [9.05] > Mastery [7.55] > Crit [6.05] > Haste [4.55] > Versatility [3.05]",
--         ["AMR"] = "Intellect 17.01 > CriticalStrike 15.69 > Mastery 13.91 > Versatility 11.69 > Haste 4.79 > Leech 4.64 > Avoidance 0.02 > MovementSpeed 0.01",
--     },
--     -- PRIEST SHADOW --
--     ["258"] = {
--         ["NOX"] = "Haste [9.05] > Crit [7.55] > Mastery [6.05] > Versatility [4.55] > Intellect [3.05]",
--         ["AMR"] = "Haste 15.1 > CriticalStrike 13.33 > Intellect 12.27 > Mastery 11.86 > Versatility 8.72 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- PRIEST DISCIPLINE --
--     ["256"] = {
--         ["NOX"] = "Intellect [9.06] > Haste [7.56] > Crit [6.06] = Mastery [6.06] > Versatility [3.06]",
--         ["AMR"] = "Intellect 16.93 > Leech 16.7 > CriticalStrike 12.56 > Mastery 11.08 > Versatility 11.06 > Haste 6.69 > Avoidance 0.02 > MovementSpeed 0.01",
--     },
--     -- ROGUE ASSASSINATION --
--     ["259"] = {
--         ["NOX"] = "Agility [9.03] > Mastery [7.53] > Versatility [6.03] > Crit [4.53] > Haste [3.03]",
--         ["AMR"] = "Agility 17.46 > Mastery 11.8 > CriticalStrike 11.01 > Versatility 8.82 > Haste 5.14 > MainHandDamage 2.24 > OffHandDamage 1.11 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- ROGUE OUTLAW --
--     ["260"] = {
--         ["NOX"] = "Agility [9.05] > Versatility [7.55] > Haste [6.05] > Crit [4.55] > Mastery [3.05]",
--         ["AMR"] = "Agility 16.35 > Mastery 12.47 > Versatility 11.02 > CriticalStrike 10.47 > Haste 10.37 > MainHandDamage 5.14 > OffHandDamage 2.59 > MovementSpeed 1.83 > Leech 0.02 > Avoidance 0.01",
--     },
--     -- ROGUE SUBTLETY --
--     ["261"] = {
--         ["NOX"] = "Agility [9.06] > Mastery [7.56] > Versatility [6.06] > Crit [4.56] > Haste [3.06]",
--         ["AMR"] = "Agility 17.02 > Mastery 11.55 > CriticalStrike 9.31 > Versatility 9.06 > MainHandDamage 5.11 > Haste 4.47 > OffHandDamage 0.77 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- SHAMAN ELEMENTAL --
--     ["262"] = {
--         ["NOX"] = "Intellect [9.07] > Mastery [7.57] > Crit [6.82] > Versatility [4.57] > Haste [3.07]",
--         ["AMR"] = "CriticalStrike 17.57 > Haste 15.61 > Intellect 15.11 > Versatility 10.2 > Mastery 7.21 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- SHAMAN ENHANCEMENT --
--     ["263"] = {
--         ["NOX"] = "Agility [9.08] > Haste [7.58] > Mastery [6.08] > Crit [4.58] > Versatility [3.08]",
--         ["AMR"] = "Agility 14.49 > Mastery 12.09 > Haste 10.96 > CriticalStrike 9.13 > Versatility 8.42 > MainHandDamage 6.68 > OffHandDamage 2.88 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- SHAMAN RESTORATION --
--     ["264"] = {
--         ["NOX"] = "Intellect [9.06] > Mastery [7.56] > Crit [6.06] > Versatility [4.56] > Haste [3.06]",
--         ["AMR"] = "Intellect 12.51 > CriticalStrike 12.46 > Mastery 9.84 > Versatility 8.81 > Haste 6.05 > Leech 3.34 > Avoidance 0.02 > MovementSpeed 0.01",
--     },
--     -- WARLOCK AFFLICTION --
--     ["265"] = {
--         ["NOX"] = "Mastery [9.05] > Crit [7.55] > Haste [6.8] > Intellect [4.55] > Versatility [3.05]",
--         ["AMR"] = "Mastery 11.11 > Intellect 9.59 > Haste 9.04 > CriticalStrike 7.63 > Versatility 6.8 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- WARLOCK DEMONOLOGY --
--     ["266"] = {
--         ["NOX"] = "Haste [9.06] > Intellect [7.56] > Crit [6.06] > Mastery [4.56] > Versatility [3.06]",
--         ["AMR"] = "Haste 14.54 > Intellect 10.01 > CriticalStrike 8.24 > Versatility 7.97 > Mastery 7.28 > Avoidance 0.03 > MovementSpeed  0.02 > Leech 0.01",
--     },
--     -- WARLOCK DESTRUCTION --
--     ["267"] = {
--         ["NOX"] = "Intellect [9.05] > Haste [7.55] > Crit [6.05] > Versatility [4.55] > Mastery [3.05]",
--         ["AMR"] = "Intellect 10.49 > Haste 10.29 > CriticalStrike 8.41 > Mastery 8.18 > Versatility 7.58 > Avoidance 0.03 > MovementSpeed 0.02 > Leech 0.01",
--     },
--     -- WARRIOR ARMS --
--     ["71"] = {
--         ["NOX"] = "Mastery [9.05] > Haste [7.55] > Strength [6.05] > Versatility [4.55] > Crit [3.05]",
--         ["AMR"] = "Haste 13.27 > MainHandDamage 12.16 > Strength 11.76 > Mastery 10.27 > CriticalStrike 9.55 > Versatility 9.23 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- WARRIOR FURY --
--     ["72"] = {
--         ["NOX"] = "Haste [9.04] > Mastery [7.54] > Versatility [6.04] > Strength [4.54] > Crit [3.04]",
--         ["AMR"] = "Haste 10 > Strength 9.68 > Versatility 7.53 > CriticalStrike 7.19 > Mastery 6.29 > MainHandDamage 6.28 > OffHandDamage 2.72 > MovementSpeed 0.03 > Avoidance 0.02 > Leech 0.01",
--     },
--     -- WARRIOR PROTECTION --
--     ["73"] = {
--         ["NOX"] = "Stamina [12.02] > Strength [9.02] > Haste [7.52] > Mastery [6.77] > Versatility [6.02] > Crit [4.52]",
--         ["AMR"] = "Armor 29.84 > Leech 16.32 > Strength 14.15 > Versatility 13.14 > Mastery 11.53 > Stamina 8.15 > CriticalStrike 2.7 > Haste 1.88 > MainHandDamage 0.03 > Avoidance 0.02 > MovementSpeed 0.01",
--     }
-- }
local rawValues = {
    -- MAGE ARCANE --
    ["62"] = {
        ["NOX"] = "Intellect [9.08] > Mastery [7.58] > Crit [6.08] > Versatility [4.58] > Haste [3.08]",
    },
    -- MAGE FIRE --
    ["63"] = {
        ["NOX"] = "Intellect [9.03] > Crit [7.53] > Mastery [6.03] > Haste [4.53] > Versatility [3.03]",
    },
    -- MAGE FROST --
    ["64"] = {
        ["NOX"] = "Intellect [9.07] > Haste [7.57] > Crit [6.07] > Versatility [4.57] > Mastery [3.07]",
    },
    -- PALADIN HOLY --
    ["65"] = {
        ["NOX"] = "Intellect [9.07] > Crit [7.57] > Mastery [6.07] > Versatility [4.57] > Haste [3.07]",
    },
    -- PALADIN PROTECTION --
    ["66"] = {
        ["NOX"] = "Stamina [15.05] > Strength [12.05] > Haste [9.05] > Versatility [7.55] > Mastery [6.05] > Crit [4.55]",
    },
    -- PALADIN RETRIBUTION --
    ["70"] = {
        ["NOX"] = "Strength [9.03] > Haste [7.53] > Crit [6.03] = Versatility [6.03] > Mastery [4.53]",
    },
    -- WARRIOR ARMS --
    ["71"] = {
        ["NOX"] = "Mastery [9.05] > Haste [7.55] > Strength [6.05] > Versatility [4.55] > Crit [3.05]",
    },
    -- WARRIOR FURY --
    ["72"] = {
        ["NOX"] = "Haste [9.04] > Mastery [7.54] > Versatility [6.04] > Strength [4.54] > Crit [3.04]",
    },
    -- WARRIOR PROTECTION --
    ["73"] = {
        ["NOX"] = "Stamina [12.02] > Strength [9.02] > Haste [7.52] > Mastery [6.77] > Versatility [6.02] > Crit [4.52]",
    },
    -- DRUID BALANCE --
    ["102"] = {
        ["NOX"] = "Haste [12.02] > Intellect [10.52] > Mastery [9.02] > Crit [7.52] > Versatility [6.02]",
    },
    -- DRUID FERAL --
    ["103"] = {
        ["NOX"] = "Agility [12.02] > Crit [10.52] > Mastery [9.02] > Versatility [7.52] > Haste [6.02]",
    },
    -- DRUID GUARDIAN --
    ["104"] = {
        ["NOX"] = "Stamina [18.04] > Versatility [14.29] > Mastery [13.54] > Haste [12.04] > Agility [10.54] > Crit [9.04]",
    },
    -- DRUID RESTORATION --
    ["105"] = {
        ["NOX"] = "Intellect [9.01] > Mastery [7.51] > Haste [6.38] > Crit [6.01] > Versatility [4.51]",
    },
    -- DK BLOOD --
    ["250"] = {
        ["NOX"] = "Stamina [12.01] > Strength [9.01] > Haste [7.51] > Versatility [6.01] > Mastery [4.51] > Crit [3.01]",
    },
    -- DK FROST --
    ["251"] = {
        ["NOX"] = "Strength [9.01] > Mastery [7.51] > Crit [6.76] > Haste [6.01] > Versatility [5.26]",
    },
    -- DK UNHOLY --
    ["252"] = {
        ["NOX"] = "Strength [9.07] > Mastery [7.57] > Haste [6.07] > Crit [4.57] = Versatility [4.57]",
    },
    -- HUNTER BEAST MASTERY --
    ["253"] = {
        ["NOX"] = "Agility [9.05] > Mastery [7.55] > Haste [6.05] > Crit [4.55] > Versatility [3.05]",
    },
    -- HUNTER MARKSMANSHIP --
    ["254"] = {
        ["NOX"] = "Mastery [9.07] > Agility [7.57] > Crit [6.07] > Haste [4.57] > Versatility [3.07]",
    },
    -- HUNTER SURVIVAL --
    ["255"] = {
        ["NOX"] = "Agility [9.06] > Haste [7.56] > Mastery [6.43] > Crit [6.06] > Versatility [4.56]",
    },
    -- PRIEST DISCIPLINE --
    ["256"] = {
        ["NOX"] = "Intellect [9.06] > Haste [7.56] > Crit [6.06] = Mastery [6.06] > Versatility [3.06]",
    },
    -- PRIEST HOLY --
    ["257"] = {
        ["NOX"] = "Intellect [9.05] > Mastery [7.55] > Crit [6.05] > Haste [4.55] > Versatility [3.05]",
    },
    -- PRIEST SHADOW --
    ["258"] = {
        ["NOX"] = "Haste [9.05] > Crit [7.55] > Mastery [6.05] > Versatility [4.55] > Intellect [3.05]",
    },
    -- ROGUE ASSASSINATION --
    ["259"] = {
        ["NOX"] = "Agility [9.03] > Mastery [7.53] > Versatility [6.03] > Crit [4.53] > Haste [3.03]",
    },
    -- ROGUE OUTLAW --
    ["260"] = {
        ["NOX"] = "Agility [9.05] > Versatility [7.55] > Haste [6.05] > Crit [4.55] > Mastery [3.05]",
    },
    -- ROGUE SUBTLETY --
    ["261"] = {
        ["NOX"] = "Agility [9.06] > Mastery [7.56] > Versatility [6.06] > Crit [4.56] > Haste [3.06]",
    },
    -- SHAMAN ELEMENTAL --
    ["262"] = {
        ["NOX"] = "Intellect [9.07] > Mastery [7.57] > Crit [6.82] > Versatility [4.57] > Haste [3.07]",
    },
    -- SHAMAN ENHANCEMENT --
    ["263"] = {
        ["NOX"] = "Agility [9.08] > Haste [7.58] > Mastery [6.08] > Crit [4.58] > Versatility [3.08]",
    },
    -- SHAMAN RESTORATION --
    ["264"] = {
        ["NOX"] = "Intellect [9.06] > Mastery [7.56] > Crit [6.06] > Versatility [4.56] > Haste [3.06]",
    },
    -- WARLOCK AFFLICTION --
    ["265"] = {
        ["NOX"] = "Mastery [9.05] > Crit [7.55] > Haste [6.8] > Intellect [4.55] > Versatility [3.05]",
    },
    -- WARLOCK DEMONOLOGY --
    ["266"] = {
        ["NOX"] = "Haste [9.06] > Intellect [7.56] > Crit [6.06] > Mastery [4.56] > Versatility [3.06]",
    },
    -- WARLOCK DESTRUCTION --
    ["267"] = {
        ["NOX"] = "Intellect [9.05] > Haste [7.55] > Crit [6.05] > Versatility [4.55] > Mastery [3.05]",
    },
    -- MONK BREWMASTER --
    ["268"] = {
        ["NOX"] = "Stamina [15.02] > Agility [12.02] > Haste [9.02] > Mastery [7.52] = Crit [7.52] > Versatility [6.02]",
    },
    -- MONK WINDWALKER --
    ["269"] = {
        ["NOX"] = "Agility [9.07] > Mastery [7.57] > Crit [6.07] > Versatility [4.57] > Haste [3.07]",
    },
    -- MONK MISTWEAVER --
    ["270"] = {
        ["NOX"] = "Intellect [9.04] > Crit [7.54] > Versatility [6.04] > Mastery [4.54] > Haste [3.04]",
    },
    -- DEMON HUNTER HAVOC --
    ["577"] = {
        ["NOX"] = "Crit [9.02] > Haste [7.52] > Versatility [6.02] > Agility [4.52] > Mastery [3.02]",
    },
    -- DEMON HUNTER VENGEANCE --
    ["581"] = {
        ["NOX"] = "Stamina [15.01] > Agility [12.01] > Versatility [9.01] > Mastery [7.51] = Haste [7.51] > Crit [4.51]",
    }
}

function GearHelper:InitTemplates()

    for spec, templates in pairs(rawValues) do
        for templateID, stats in pairs(templates) do
            -- print("Spec : "..spec)
            -- print("TID : "..templateID)
            -- print("Stats : "..stats)
            ParseDefaultValues(stats, spec, templateID)
        end
    end
end
